{{ if or (gt .WordCount 400 ) (.Params.toc) }}
{{ $startLevel := .Site.Params.tocStartLevel | default 2 }}
{{ $endLevel := .Site.Params.tocEndLevel | default 3 }}
{{ $tagRe := printf "h[%d-%d]" $startLevel $endLevel }}
{{ $tocRe := printf "<%s.*?>(.|\n])+?</%s>" $tagRe $tagRe }}
{{ $headers := findRE $tocRe .Content   }}
<aside class="menu">
    <a data-action="collapse" href="#">
        <p class="menu-label">
            Table of Contents ⌃
        </p>
    </a>
    <ul class="menu-list is-collapsible is-active">
        {{ $first_ul := 0 }}
        {{ $last_ul := 0 }}
        {{range $index, $hdr := $headers}}
        {{- $tagname := substr $hdr 1 2 -}}
        {{- $header := $hdr | plainify | htmlUnescape -}}
        {{ if and ($first_ul) (eq $tagname "h3") }}{{ safeHTML "<ul>" }}{{ $first_ul = 0 }}{{ $last_ul = 1 }}{{ end }}
        {{ if and ($last_ul) (eq $tagname "h2") }}{{ safeHTML "</ul>" }}{{ $last_ul = 0 }}{{ end }}
        {{- if and (gt $index 0 ) (eq $tagname "h2") -}}{{ safeHTML "</li>" }}{{- end -}}
        {{- if eq $tagname "h2" -}}{{ safeHTML "<li>" }}{{ else }}{{ safeHTML "<li class='is-hidden-touch'>" }}{{- end -}}
        <a href='#{{ $header | anchorize }}'>{{ $header }}</a>
        {{ if (eq $tagname "h2") }}{{ $first_ul = 1 }}{{- end -}}
        {{- if (eq $tagname "h3") -}}{{ safeHTML "</li>" }}{{- end -}}
        {{ end }}
        {{ safeHTML "</ul></li>" }}
    </ul>
</aside>
{{ end }}